#!/usr/bin/env python

class DSUID(object):
    def __init__(self, _list):
        self.octets = _list
    def __repr__(self):
        return ":".join(map(lambda x: "%02X" % x, self.octets))
        # return list2str(self.dsid)

dsuids = set()

def intern_DSUID(dsuid):
    assert(type(dsuid) == list)
    for _dsuid in dsuids:
        if _dsuid.octets == dsuid:
            return _dsuid
    new = DSUID(dsuid)
    dsuids.add(new)
    return new

# dsm-api
ct = 0x1717171700
def createDsmId():
    global ct
    # bit[7] & 0xf0 == 0x10, ignore here
    model = [0x35, 0x04, 0x17, 0x5f, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10]

    ct += 0x100
    tmp = ct
    serial = []
    while tmp != 0:
        serial.append(tmp & 0xff)
        tmp >>= 8
    serial.reverse()

    ret = list(model)
    ret.extend(serial)

    assert(len(ret) == 17)
    return ret

def createDssId():
    # just make it different from above
    tmp = createDsmId()
    tmp[0] = 0x36
    return tmp

if __name__ == "__main__":
    dsmid = createDsmId()
    i = intern_DSUID(dsmid)
    j = intern_DSUID(dsmid)
    assert(i == j)
    k = intern_DSUID(list(dsmid))
    assert(i == k)

    print [d.octets for d in [ i, j]]
